//+------------------------------------------------------------------+
//|                                                 HULL_ANTICIP.mq4 |
//|                                                     Manu29 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Manu29"
#property link      ""

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Blue

//---- input parameters
extern int       HullAntPeriod=24;

//---- buffers
double TempBuf1[];
double TempBuf2[];
double HullAntBuf[];

//Variable
int HalfHullAntPeriod;
int SqrtHullAntPeriod;

//+------------------------------------------------------------------+
//| Specific functions                                               |
//+------------------------------------------------------------------+
double ComputeHull(int ActualBar)
{
   double CloseTemp[];
   double Temp[];
   double Temp1, Temp2;
   double result = -1;
   int    i;

   //Copy Close Values to CloseTemp
   ArrayResize(CloseTemp, HullAntPeriod+SqrtHullAntPeriod);
   ArrayCopy(CloseTemp, Close, 0, ActualBar, HullAntPeriod+SqrtHullAntPeriod);
   ArraySetAsSeries(CloseTemp, true); 
   ArrayResize(Temp, SqrtHullAntPeriod);
   
   //HMA value computation
   for(i=0; i<SqrtHullAntPeriod; i++)
   {  
      Temp1 = iMAOnArray(CloseTemp, 0, HalfHullAntPeriod, 0, MODE_LWMA, i);
      Temp2 = iMAOnArray(CloseTemp, 0, HullAntPeriod, 0, MODE_LWMA, i);
      Temp[i] = 2*Temp1-Temp2;
   }
   ArraySetAsSeries(Temp, true); 
   result = iMAOnArray(Temp, 0, SqrtHullAntPeriod, 0, MODE_LWMA, 0);

//---- done
   return(result);
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 1 additional buffers are used for temporary data.
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_NONE);
//---- 2 indicator buffers mapping
   SetIndexBuffer(0,HullAntBuf);
   SetIndexBuffer(1,TempBuf1);
   SetIndexBuffer(2,TempBuf2);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("HULL ANTICIP("+HullAntPeriod+")");
   SetIndexLabel(0,"HULL ANTICIPATION");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);

//---- Specific indicator initialization
   HalfHullAntPeriod = MathRound(HullAntPeriod/2);
   SqrtHullAntPeriod = MathRound(MathSqrt(HullAntPeriod));

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int bar, limit, i;   
   int counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(i=0; i<limit; i++)
      HullAntBuf[i]=ComputeHull(i);
//----
   return(0);
  }
//+------------------------------------------------------------------+